package org.n52.connectors.core;

import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import org.n52.connectors.core.exceptions.IllegalConnectorRequest;
import org.n52.connectors.core.exceptions.N52Exception;
import org.n52.connectors.core.exceptions.WrappedException;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

public class ConnectorFactory extends AbstractFactory {

@Override
	public Connector getConnector(ConnectorRequest request) throws N52Exception {
		if ( registries == null)
			throw new IllegalConnectorRequest("No registries defined, request can not be handled");
		
	for(ConnectorTypeRegistry registry: registries) {
		try {
			
					String respons = registry.getConnectorClass(request);
					URL classUrl = new URL("http://empty");
					String className = new String();
					Document doc = getClassInfo(respons);
			        className = getNodeValue(doc.getDocumentElement(), "classname");
	        		classUrl = new URL(getNodeValue(doc.getDocumentElement(), "classUrl"));
					if ( classUrl.equals(""))
						continue;
					
				    URL[] urlsToLoadFrom = new URL[]{classUrl};
				    URLClassLoader loader = new URLClassLoader(urlsToLoadFrom);	
				    Class connectorClass = Class.forName(className, true, loader);
				    Connector conn =  (Connector) connectorClass.newInstance();
				    conn.factorySideInitialization(doc, request);
				    return conn;
			}
			catch (ClassNotFoundException ex) {
				throw new WrappedException(ex);
			} catch (InstantiationException ex) {
				throw new WrappedException(ex);
			} catch (IllegalAccessException ex) {
				throw new WrappedException(ex);
			} catch (SAXException ex) {
				throw new WrappedException(ex);
			} catch (IOException ex) {
				throw new WrappedException(ex);
			} catch (TransformerException ex) {
				throw new WrappedException(ex);
			} catch (ParserConfigurationException ex) {
				throw new WrappedException(ex);
			}
			
		}
		return null;
	}	@Override
	public Connector[] getConnectors(ConnectorRequest request) {
		// TODO Auto-generated method stub
		return null;
	}

}
