

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;

import junit.framework.TestCase;

import org.geotools.data.FeatureReader;
import org.geotools.data.FeatureResults;
import org.geotools.data.FeatureSource;
import org.geotools.data.shapefile.ShapefileDataStore;
import org.geotools.feature.Feature;
import org.geotools.feature.IllegalAttributeException;
import org.n52.connectors.core.LocalConnectorTypeRegistry;
import org.n52.connectors.core.ServiceFactory;
import org.n52.connectors.core.ServiceRequest;
import org.n52.connectors.core.exceptions.IllegalDefaultSettingException;
import org.n52.connectors.core.exceptions.N52Exception;
import org.n52.connectors.core.exceptions.WrappedException;
import org.n52.connectors.impl.N52Operation;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.CoordinateSequence;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.LineString;
import com.vividsolutions.jts.geom.impl.CoordinateArraySequence;

public class TestAdjacency extends TestCase {

	/*
	 * Test method for 'n52.operations.gs.spatial.location.coord.select.AdjacencyListByGeometry.getAdjecencyList(List<Feature>)'
	 */
	public void testGetAdjecencyList() {
		try {
			File f = new File("D:/EclipseProjects/CoreConnectors/TestData/join2000.shp");
			URL shapeURL = f.toURL();
			if ( !f.exists())
				return;
			
		
			ShapefileDataStore store = new ShapefileDataStore(shapeURL);
			String name = store.getTypeNames()[0];
			FeatureSource source = store.getFeatureSource(name);
			FeatureResults fsShape = source.getFeatures();
			ArrayList<Feature> features = new ArrayList<Feature>();
			FeatureReader reader = fsShape.reader();
			while (reader.hasNext()) {
			    Feature feature = reader.next();
			    features.add(feature);
			    
			}
			
			LocalConnectorTypeRegistry registry = new LocalConnectorTypeRegistry("D:/EclipseProjects/CoreConnectors/N52Operations");
			ServiceFactory factory = new ServiceFactory();
			factory.addRegistry(registry);
			
			Coordinate [] crd = new Coordinate[2];
			crd[0] = new Coordinate();
			crd[0].x = 169.0;
			crd[0].y = 610.0;
			crd[1] = new Coordinate();
			crd[1].x = 174.0;
			crd[1].y = 607.0;
			GeometryFactory geofac = features.get(0).getDefaultGeometry().getFactory();
			CoordinateSequence seq = new CoordinateArraySequence(crd);
	    	LineString line = new LineString(seq, geofac);
	    	
			ServiceRequest req = new ServiceRequest();
			req.put("service", "gs.spatial.location.coord.select.adjacencybygeometry");
			N52Operation op = (N52Operation) factory.getServiceAdapter(req);
			
			HashMap inputData = new HashMap();
			HashMap params = new HashMap();
			inputData.put("features", features);
			params.put("method", "neighbourhood");
			params.put("anchor", line);
			params.put("attribute", "GRID_CODE");
			
			Map result = op.execute(inputData, params); 
			ArrayList l = (ArrayList)result.get("sortedlist");
			
			
			
			
//			ShapefileDataStore store = new ShapefileDataStore(shapeURL);
//			String name = store.getTypeNames()[0];
//			FeatureSource source = store.getFeatureSource(name);
//			FeatureResults fsShape = source.getFeatures();
//			ArrayList<Feature> features = new ArrayList<Feature>();
//			FeatureReader reader = fsShape.reader();
//			while (reader.hasNext()) {
//			    Feature feature = reader.next();
//			    features.add(feature);
//			    
//			}
//			reader.close();
//			AdjacencyListByGeometry adj = new AdjacencyListByGeometry();
//			Coordinate [] crd = new Coordinate[2];
//			crd[0] = new Coordinate();
//			crd[0].x = 186314.92;
//			crd[0].y = 539245.50;
//			crd[1] = new Coordinate();
//			crd[1].x = 265335.55;
//			crd[1].y = 463546.75;
//			GeometryFactory geofac = features.get(0).getDefaultGeometry().getFactory();
//			CoordinateSequence seq = new CoordinateArraySequence(crd);
//	    	LineString line = new LineString(seq, geofac);
//
//			
//			adj.setAnchor(line);
//			adj.setMethod(AdjacencyListByGeometry.Methods.byNeighbourhood);
//			java.util.List<Feature> out = adj.getAdjecencyList(features);
//			System.out.println(out.size());
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchElementException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (WrappedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalDefaultSettingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (N52Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAttributeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	/*
	 * Test method for 'n52.operations.gs.spatial.location.coord.select.AdjacencyListByGeometry.setAnchor(Geometry)'
	 */
	public void testSetAnchor() {

	}

	/*
	 * Test method for 'n52.operations.gs.spatial.location.coord.select.AdjacencyListByGeometry.setMethod(Methods)'
	 */
	public void testSetMethod() {

	}

}
