package org.n52.connectors.testcases;

import java.io.IOException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;

import javax.units.ConversionException;

import org.geotools.data.DataStore;
import org.geotools.data.DefaultQuery;
import org.geotools.data.FeatureReader;
import org.geotools.data.Query;
import org.geotools.data.Transaction;
import org.geotools.data.wfs.WFSDataStoreFactory;
import org.geotools.feature.Feature;
import org.geotools.feature.IllegalAttributeException;

import com.vividsolutions.jts.geom.Envelope;

/**
 * <p> 
 * An example use of the WFS data store
 * </p>
 * @author dzwiers Refractions Research
 *
 */
public class WFSDemo {
    public static void main(String[] args){
        System.out.println("WFS Demo");
        try{
//            URL url = new URL("http://www2.dmsolutions.ca/cgi-bin/mswfs_gmap?version=1.0.0&request=getcapabilities&service=wfs");
        	URL url = new URL("http://www.refractions.net:8080/geoserver/wfs?REQUEST=GetCapabilities");
        
            Map m = new HashMap();
            ConversionException ex = null;
            m.put(WFSDataStoreFactory.URL.key,url);
            m.put(WFSDataStoreFactory.TIMEOUT.key,new Integer(10000));
            m.put(WFSDataStoreFactory.PROTOCOL.key,Boolean.FALSE);

            DataStore wfs = (new WFSDataStoreFactory()).createNewDataStore(m);
            Query query = new DefaultQuery(wfs.getTypeNames()[1]);
            FeatureReader ft = wfs.getFeatureReader(query,Transaction.AUTO_COMMIT);
            int count = 0;
            while(ft.hasNext()) {
            	Feature fte = ft.next();
            	Envelope env = fte.getBounds();
                if(fte !=null)
                    count++;
            }
            System.out.println("Found "+count+" features");
        }catch(IOException e){
            e.printStackTrace();
        } catch (NoSuchElementException e) {
            e.printStackTrace();
        } catch (IllegalAttributeException e) {
            e.printStackTrace();
        }
    }
}
